<template>
  <a-spin :spinning="loading">
    <a-upload
      :show-upload-list="false"
      :custom-request="uploadS3"
      :before-upload="beforeUpload"
      @change="handleChange"
      name="avatar"
      list-type="picture-card"
      class="avatar-uploader"
      accept="image/*"
      action="/upload.do"
    >
      <img v-if="imageUrl" :src="imageUrl" alt="avatar">
      <div v-else>
        <!-- <a-icon :type="loading ? 'loading' : 'plus'" /> -->
        <a-icon
          :type="loading ? 'loading' : 'cloud-upload-o'"
          class="upload-icon"
        />
      </div>
    </a-upload>
  </a-spin>
</template>
<script>
import { Storage } from 'aws-amplify'
import { mapGetters } from 'vuex'

export default {
  props: {
    initUrl: {
      type: String,
      default: () => {
        return ''
      }
    }
  },
  data () {
    return {
      loading: false,
      imageUrl: this.initUrl
    }
  },
  computed: {
    ...mapGetters('auth', {
      identityId: 'identityId'
    })
  },
  methods: {
    handleChange (info) {
      if (info.file.status === 'uploading') {
        this.loading = true
        return
      }
      if (info.file.status === 'done') {
        const { response } = info.file
        this.imageUrl = response
        this.loading = false
        this.$emit('success', response)
      }
    },
    uploadS3 ({ data, file, onError, onProgress, onSuccess }) {
      const key = `${file.name}`
      const level = 'protected'
      Storage.put(key, file, {
        level,
        contentType: file.type,
        progressCallback ({ total, loaded }) {
          onProgress({ percent: Math.round((loaded / total) * 100) }, file)
        }
      })
        .then((res) => {
          const { key } = res
          const {
            AWSS3: { bucket, region }
          } = Storage._config
          let path = `${level}/${this.identityId}/${key}`
          path = `https://${bucket}.s3-${region}.amazonaws.com/${path}`
          return path
        })
        .then(path => onSuccess(path, file))
        .catch(onError)

      return {
        abort () {
          console.log('upload progress is aborted.')
        }
      }
    },
    beforeUpload (file) {
      const isLt2M = file.size / 1024 / 1024 < 20
      if (!isLt2M) {
        this.$message.error('画像は20MB未満でなければなりません！')
      }
      return isLt2M
    }
  }
}
</script>
<style lang="scss" scoped>
.upload-icon {
  font-size: 1.4rem;
  padding: 0.5rem;
  background: rgba(222, 221, 221, 0.7);
  border-radius: 50%;
  border: 1px solid rgba(0, 0, 0, 0.2);
}

.avatar-uploader {
  .ant-upload.ant-upload-select-picture-card {
    border-radius: 50% !important;
    min-height: 180px;
    img {
      width: 160px;
      height: 160px;
      border-radius: 50%;
      overflow: hidden;
    }
  }
  .ant-upload {
    width: 100%;
    height: 100%;
  }
}
</style>
